



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Oracle 多行记录合并/连接/聚合字符串的几种方法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Oracle 多行记录合并/连接/聚合字符串的几种方法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 15:38:08 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>怎么合并多行记录的字符串，一直是oracle新手喜欢问的SQL问题之一，关于这个问题的帖子我看过不下30个了，现在就对这个问题，进行一个总结。<br />-<br />什么是合并多行字符串（连接字符串）呢，例如：</p>
<div>
<pre class="prettyprint linenums"> SQL&gt; desc test;<br />
 Name Type Nullable Default Comments<br />
 ------- ------------ -------- ------- --------<br />
 COUNTRY VARCHAR2(20) Y<br />
 CITY VARCHAR2(20) Y 

 SQL&gt; select * from test; 

 COUNTRY CITY<br />
 -------------------- --------------------<br />
 中国 台北<br />
 中国 香港<br />
 中国 上海<br />
 日本 东京<br />
 日本 大阪 </pre>
</div>
<p>要求得到如下结果集：</p>
<div>
<pre class="prettyprint linenums"> ------- --------------------<br />
 中国 台北,香港,上海<br />
 日本 东京，大阪 </pre>
</div>
<p>实际就是对字符实现一个聚合功能，我很奇怪为什么Oracle没有提供官方的聚合函数来实现它呢：） <br />下面就对几种经常提及的解决方案进行分析（有一个评测标准最高★★★★★）： <br />1.被集合字段范围小且固定型 灵活性★ 性能★★★★ 难度 ★ <br />这种方法的原理在于你已经知道CITY字段的值有几种，且还不算太多，如果太多这个SQL就会相当的长。。看例子：</p>
<div>
<pre class="prettyprint linenums"> SQL&gt; select t.country,<br />
 2 MAX(decode(t.city,'台北',t.city||',',NULL)) ||<br />
 3 MAX(decode(t.city,'香港',t.city||',',NULL))||<br />
 4 MAX(decode(t.city,'上海',t.city||',',NULL))||<br />
 5 MAX(decode(t.city,'东京',t.city||',',NULL))||<br />
 6 MAX(decode(t.city,'大阪',t.city||',',NULL))<br />
 7 from test t GROUP BY t.country<br />
 8 / 

 COUNTRY MAX(DECODE(T.CITY,'台北',T.CIT<br />
 -------------------- ------------------------------<br />
 中国 台北,香港,上海,<br />
 日本 东京,大阪, </pre>
</div>
<p>大家一看，估计就明白了（如果不明白，好好补习MAX DECODE和分组）。这种方法无愧为最笨的方法，但是对某些应用来说，最有效的方法也许就是它。 <br />2.固定表固定字段函数法 灵活性★★ 性能★★★★ 难度 ★★ <br />此法必须预先知道是哪个表，也就是说一个表就得写一个函数，不过方法1的一个取值就要便捷多了。在大多数应用中，也不会存在大量这种合并字符串的需求。废话完毕，看下面： <br />定义一个函数</p>
<div>
<pre class="prettyprint linenums"> create or replace function str_list( str_in in varchar2 )--分类字段<br />
 return varchar2<br />
 is<br />
 str_list varchar2(4000) default null;--连接后字符串<br />
 str varchar2(20) default null;--连接符号<br />
 begin<br />
 for x in ( select TEST.CITY from TEST where TEST.COUNTRY = str_in ) loop<br />
 str_list := str_list || str || to_char(x.city);<br />
 str := ', ';<br />
 end loop;<br />
 return str_list;<br />
 end; </pre>
</div>
<p>使用：</p>
<div>
<pre class="prettyprint linenums"> SQL&gt; select DISTINCT(T.country),list_func1(t.country) from test t; 

 COUNTRY LIST_FUNC1(T.COUNTRY)<br />
 -------------------- ----------------<br />
 中国 台北, 香港, 上海<br />
 日本 东京, 大阪 

 SQL&gt; select t.country,str_list(t.country) from test t GROUP BY t.country; 

 COUNTRY STR_LIST(T.COUNTRY)<br />
 -------------------- -----------------------<br />
 中国 台北, 香港, 上海<br />
 日本 东京, 大阪 </pre>
</div>
<p>这个时候，使用分组和求唯一都可以满足要求。它的原理就是，根据唯一的分组字段country，在函数里面再次查询该字段对应的所有被合并列，使用PL/SQL将其合并输出。 <br />3.灵活表函数法 灵活性★★★ 性能★★★ 难度 ★★★ <br />该方法是在方法2的基础上，使用动态SQL，将表名和字段名称传入，从而达到灵活的目的。</p>
<div>
<pre class="prettyprint linenums"> create or replace function str_list2( key_name in varchar2,<br />
 key in varchar2,<br />
 coname in varchar2,<br />
 tname in varchar2 )<br />
 return varchar2<br />
 as<br />
 type rc is ref cursor;<br />
 str varchar2(4000);<br />
 sep varchar2(2);<br />
 val varchar2(4000);<br />
 cur rc;<br />
 begin<br />
 open cur for 'select '||coname||'<br />
 from '|| tname || '<br />
 where ' || key_name || ' = :x '<br />
 using key;<br />
 loop<br />
 fetch cur into val;<br />
 exit when cur%notfound;<br />
 str := str || sep || val;<br />
 sep := ', ';<br />
 end loop;<br />
 close cur;<br />
 return str;<br />
 end;<br />
 SQL&gt; select test.country,<br />
 2 str_list2('COUNTRY', test.country, 'CITY', 'TEST') emplist<br />
 3 from test<br />
 4 group by test.country<br />
 5 / 

 COUNTRY EMPLIST<br />
 -------------------- -----------------<br />
 中国 台北, 香港, 上海<br />
 日本 东京, 大阪 </pre>
</div>
<p>4.一条SQL法 灵活性★★★★ 性能★★ 难度 ★★★★ <br />一条SQL的法则是某位大师提出的，大家曾经在某个时期都乐此不彼的寻求各种的问题一条SQL法，但是大师的意思似乎被曲解，很多性能差，可读性差，灵活差的SQL都是这个原则产物，所谓画虎不成反成犬类。不过，解决问题始终是第一原则，这里还是给出一个比较有代表性的一条SQL方法。</p>
<div>
<pre class="prettyprint linenums"> SELECT country,max(substr(city,2)) city<br />
 FROM<br />
 (SELECT country,sys_connect_by_path(city,',') city<br />
 FROM<br />
 (SELECT country,city,country||rn rchild,country||(rn-1) rfather<br />
 FROM<br />
 (SELECT test.country ,test.city,row_number() over (PARTITION BY test.country ORDER BY test.city) rn FROM test))<br />
 CONNECT BY PRIOR rchild=rfather START WITH rfather LIKE '%0')<br />
 GROUP BY country;<br />
 下面分步解析，有4个FROM，就有4次结果集的操作。<br />
 step 1 给记录加上序号rn<br />
 SQL&gt; SELECT test.country ,test.city,row_number() over (PARTITION BY test.country ORDER BY test.city) rn<br />
 2 FROM test<br />
 3 / 

 COUNTRY CITY RN<br />
 -------------------- -------------------- ----------<br />
 日本 大阪 1<br />
 日本 东京 2<br />
 中国 上海 1<br />
 中国 台北 2<br />
 中国 香港 3 </pre>
</div>
<p>step 2 创造子节点父节点</p>
<div>
<pre class="prettyprint linenums"> SQL&gt; SELECT country,city,country||rn rchild,country||(rn-1) rfather<br />
 2 FROM<br />
 3 (SELECT test.country ,test.city,row_number() over (PARTITION BY test.country ORDER BY test.city) rn<br />
 4 FROM test)<br />
 5 /<br />
 日本 大阪 日本1 日本0<br />
 日本 东京 日本2 日本1<br />
 中国 上海 中国1 中国0<br />
 中国 台北 中国2 中国1<br />
 中国 香港 中国3 中国2<br />
 step 3 利用sys_connect_by_path生成结果集<br />
 SELECT country,sys_connect_by_path(city,',') city<br />
 FROM<br />
 (SELECT country,city,country||rn rchild,country||(rn-1) rfather<br />
 FROM<br />
 (SELECT test.country ,test.city,row_number() over (PARTITION BY test.country ORDER BY test.city) rn FROM test)) CONNECT BY PRIOR rchild=rfather START WITH rfather LIKE '%0'<br />
 日本 ,大阪<br />
 日本 ,大阪,东京<br />
 中国 ,上海<br />
 中国 ,上海,台北<br />
 中国 ,上海,台北,香港<br />
 step 4 最终步骤，筛选结果集合<br />
 SQL&gt; SELECT country,max(substr(city,2)) city<br />
 2 FROM<br />
 3 (SELECT country,sys_connect_by_path(city,',') city<br />
 4 FROM<br />
 5 (SELECT country,city,country||rn rchild,country||(rn-1) rfather<br />
 6 FROM<br />
 7 (SELECT test.country ,test.city,row_number() over (PARTITION BY test.country ORDER BY test.city) rn<br />
 8 FROM test))<br />
 9 CONNECT BY PRIOR rchild=rfather START WITH rfather LIKE '%0')<br />
 10 GROUP BY country; 

 COUNTRY CITY<br />
 -------------------- -------<br />
 中国 上海,台北,香港<br />
 日本 大阪,东京 </pre>
</div>
<p>可谓是，7歪8搞，最后还是弄出来了，呵呵。 PS:(逻辑上是对的..但是写的比较繁琐,可以简化!) <br />5.自定义聚合函数 灵活性★★★★★ 性能★★★★★ 难度 ★★★★★ <br />最后一个方法是我认为&ldquo;王道&rdquo;的方法，自定义聚合函数。 <br />就如何我在本开始说的，为啥oracle没有这种聚合函数呢？我也不知道，但oracle提供了聚合函数的API可以让我方便的自己定义聚合函数。 <br />详细可以看Oracle Data Catridge guide这个文档。连接如下： <br /><a href="http://www.oracle.com.cn/other/9ionlinedoc/appdev.920/a96595/toc.htm" rel="external nofollow noreferrer">http://www.oracle.com.cn/other/9ionlinedoc/appdev.920/a96595/toc.htm</a> <br />下面给出一个简单的例子：</p>
<div>
<pre class="prettyprint linenums"> SQL&gt; SELECT t.country,strcat(t.city) FROM test t GROUP BY t.country; 

 COUNTRY STRCAT(T.CITY)<br />
 -------------------- ------------------<br />
 日本 东京,大阪<br />
 中国 台北,香港,上海<br />
 简单吧，和官方的函数一样的便捷高效。<br />
 函数：<br />
 CREATE OR REPLACE FUNCTION strcat(input varchar2 )<br />
 RETURN varchar2<br />
 PARALLEL_ENABLE AGGREGATE USING strcat_type;<br />
 TYPE:<br />
 create or replace type strcat_type as object (<br />
 cat_string varchar2(4000),<br />
 static function ODCIAggregateInitialize(cs_ctx In Out strcat_type) return number,<br />
 member function ODCIAggregateIterate(self In Out strcat_type,value in varchar2) return number,<br />
 member function ODCIAggregateMerge(self In Out strcat_type,ctx2 In Out strcat_type) return number,member function ODCIAggregateTerminate(self In Out strcat_type,returnValue Out<br />
 varchar2,flags in number) return number) </pre>
</div>
<p>6.待发掘...</p>
<p>PS: 在 oracle 10g下,可以使用以下系统函数:</p>
<div>
<pre class="prettyprint linenums"> select id,WMSYS.WM_CONCAT(oid) oid<br />
 from table1<br />
 group by id </pre>
</div>
<p>总结，合并字符串还有更多的方法希望大家能发掘，本文的目的主要是抛砖引玉，如果有新的发现我会继续更新方法。</p>
<p>需要注意的问题是，本文采用varchar2为例子，所以长度有限制，oracle的版本对方法的实现也影响。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4pwj5q.html">FineReport实现根据点击次数奇偶性排序的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd50xx9.html">&lbrack;bigdata&rsqb; spark集群安装及测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/3901er38.html">dubbo-admin-2&period;5&period;3 运行报错： Bean property &amp;&num;39&semi;URIType&amp;&num;39&semi; is not writable or has an invalid 解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o20719.html">TP框架中用tp模版迁移smarty模版的注意事项</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyl2rm8.html">HTML Table导出为Excel的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv6poy8.html">&lbrack;转&rsqb;Java总结篇系列：Java泛型</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx0zp0q.html">Android源码剖析之Framework层实战版（Ams管理Activity启动）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm166e9.html">vs2013中把解决方案上传到SVN服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/96omd7n9.html">Gvim for php 安装配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o7oov9.html">HDU 查找最大元素 2025</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0nmzwq.html">SVN 命令行 精编版</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxng3gd8.html">关于cocoapods和swift中使用oc第三方</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnvo3v8.html">数据库中的schema概念</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd3zmk8.html">HoG feature for human detection（HoG 行人识别）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzd05w8.html">Scala类型系统&lpar;sudden thought&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rdvp39.html">ACM&sol;ICPC 2018亚洲区预选赛北京赛站网络赛D-80 Days--------树状数组</a>
		</li>
						<li><a href="https://www.batexi.com/a/96075049.html">jenkins 构建</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jox7eq.html">重绘（Repaint）和回流（Reflow）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd715j9.html">&lbrack;转&rsqb;使用STM32CubeMX：USB大容量存储设备</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jeg03q.html">WebDriver高级应用实例（5）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/95xjno08.html">NPOI--操作Excel之利器&lpar;二&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnerde8.html">SQLSERVER 启用跨库查询脚本</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn156jk8.html">IIS7下swfupload上传大文件出现404错误</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mnv2gq.html">使用eBay API基本步骤介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rd0x448.html">获取Class对象的方法及Class类型的一些讨论</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlm54o09.html">SharedSDK微信分享不成功，分享之后没有反应</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ok5ey59.html">【转】使用Memcached提高&period;NET应用程序的性能</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vegkj8.html">Microsoft&period;Xna&period;Framework&period;TitleContainer&period;OpenStream&lpar;&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/96o5e1j9.html">《RHEL6硬盘的分区和swap分区管理》&mdash;&mdash;硬盘分区的大总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xnmln9.html">MySQL 性能优化</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
